
Include "b3d_dx9.bb"

;
;DX9_SetAntiAliasType(AA4SAMPLES )
xGraphics3D 800, 600, 32, 0,0


;  
xSetTextureFiltering TF_ANISOTROPIC

; 
Global gCamera = xCreateCamera()
xPositionEntity gCamera, 0, 40, -100
xRotateEntity gCamera, 10, 0, 0

;  
light = xCreateLight()


pl= xCreateCube ()
xScaleEntity pl, 100,0.001,100
xEntityColor pl,200,0,0



PxCreateWorld(1,"key")
pxSetGravity(0, -9, 0)


cube = xCreateCube ()
xScaleEntity cube,10,1,1
cube_body = pxBodyCreateCube(10,1,1,0)
pxBodySetPosition(cube_body,0,30,10)

cube1 = xCreateCube ()
xScaleEntity cube1,3,3,3
cube1_body = pxBodyCreateCube(3,3,3,50)
pxBodySetPosition(cube1_body,10,30,-5)

tex = xLoadTexture ("../PhysX media/Logo.jpg")
;---------- Create Cloth Meshes----------
cloth_mesh = xLoadMesh ("../PhysX media/pol.b3d")
xEntityTexture cloth_mesh, tex

xPositionMesh cloth_mesh,0,30,0
xEntityFX cloth_mesh,16

VB = xGetMeshVB(cloth_mesh)
VB_size = xGetMeshVBSize(cloth_mesh)
IB = xGetMeshIB(cloth_mesh )
IB_size=xGetMeshIBSize(cloth_mesh)

cloth_body = pxCreateTearebleClothSpec(VB, IB, VB_size, IB_size)
pxClothAttachToCollidingShapes(cloth_body, 0)

timer = CreateTimer (60)

; 
While Not xKeyDown(1) Or xWinMessage("WM_CLOSE")
	
WaitTimer (timer)

	If xKeyDown(KEY_W)    Then xMoveEntity gCamera,  0,  0,  1
	If xKeyDown(KEY_S)    Then xMoveEntity gCamera,  0,  0, -1
	If xKeyDown(KEY_A)    Then xMoveEntity gCamera, -1,  0,  0  
	If xKeyDown(KEY_D)    Then xMoveEntity gCamera,  1,  0,  0
	If xKeyDown(KEY_PGUP) Then xMoveEntity gCamera,  0,  1,  0
	If xKeyDown(KEY_PGDN) Then xMoveEntity gCamera,  0, -1,  0
	; 
	If xKeyDown(KEY_UP)    Then xTurnEntity gCamera, -1,  0, 0, True
	If xKeyDown(KEY_DOWN)  Then xTurnEntity gCamera,  1,  0, 0, True
	If xKeyDown(KEY_LEFT)  Then xTurnEntity gCamera,  0,  1, 0, True
	If xKeyDown(KEY_RIGHT) Then xTurnEntity gCamera,  0, -1, 0, True

time=MilliSecs ()
	pxRenderPhysic(60,0)
	SetMeshToClothBody(cloth_mesh%, cloth_body%)
	xUpdatePhysxPose(cube)
	pxDX9BodySetEntity(cube, cube_body)
	xUpdatePhysxPose(cube1)
	pxDX9BodySetEntity(cube1, cube1_body) 
New_time=MilliSecs ()-time


	xRenderWorld()
	
	; FPS
	xText 10, 10, "FPS: " + xGetFPS()+"  DLL Time: "+ New_time


	; 
	xFlip

Wend


Type Px_SoftBody
	Field SB_body%
	Field SB_mesh%
End Type

Function SetMeshToClothBody(mesh%, CLB%)

	nvert = pxClothGetNumTearVertex(CLB)
	nind = pxClothGetNumTearTris(CLB)

	pvbank = pxBufferCreate(nvert*3)
	pibank = pxIntBufferCreate(nind*3)
	ppibank = pxIntBufferCreate(nvert)
	pnbank = pxBufferCreate(nvert*3)
	;pxClothGetVertexPos(CLB, pvbank, nvert)
	pxClothGetNormals(CLB, pnbank)

	pxClothGetTearVertex(CLB, pvbank)
	pxClothGetTearIndices (CLB, pibank)
	pxClothGetTearPIndices(CLB, ppibank)

	xSetMeshVNIB(mesh%, pvbank, pnbank, pibank, ppibank, nvert, nind)
	;xUpdateMeshVBPositions(mesh%, pvbank%)
	;xUpdateMeshVBNormals(mesh%, nbank%)
	;xUpdateMeshIB(mesh, pibank)

	pxBufferDelete(pvbank)
	pxBufferDelete(pibank)
	pxBufferDelete(ppibank)
	pxBufferDelete(nbank)
End Function

