Include "b3d_dx9.bb"

xGraphics3D 640,480,32,0,1

;light
light=xCreateLight(1)
xPositionEntity light,0,50,20

;cam
campiv=xCreatePivot()

cam=xCreateCamera()
xPositionEntity cam,0,17,-35
xPointEntity cam,campiv
xEntityParent cam,campiv

;plane
plane=xCreateCube( )
XScaleEntity plane, 1000,0.1,1000
tile1=xLoadTexture("../PhysX media/tile.jpg")
;xScaleTexture tile1,105,105
xEntityTexture plane,tile1

sp = xCreateSphere ()
xEntityColor sp,0,255,0
xScaleEntity sp,0.4,0.4,0.4

;physX
PxCreateWorld(1, "key")
pxSetGravity(0,-10,0)

;cube physic
xcubic=PxBodyCreateCube(2,2,2,1)
pxBodySetPosition(xcubic,0,6,0)
cubic=xCreateCube()
xScaleEntity cubic,2,2,2
tile2=xLoadTexture("../PhysX media/cub.jpg")
xScaleTexture tile2,0.2,0.2
xEntityTexture cubic,tile2

;cube physic
xcubic1=PxBodyCreateCube(2, 2, 2, 1)
pxBodySetPosition(xcubic1,0,2.5,0)
cubic1=xCreateCube()
xScaleEntity cubic1,2,2,2
tile2=xLoadTexture("../PhysX media/cub.jpg")
xScaleTexture tile2,0.2,0.2
xEntityTexture cubic1,tile2

;cube physic
xcubic2=PxBodyCreateCube(2, 2, 2, 1)
pxBodySetPosition(xcubic2,5,5,0)
cubic2=xCreateCube()
xScaleEntity cubic2,2,2,2
tile2=xLoadTexture("../PhysX media/cub.jpg")
xScaleTexture tile2,0.2,0.2
xEntityTexture cubic2,tile2

;Ray
Ray = pxCreateRay()
pxRaySetDir(ray, 0, -1, 0)
pxRaySetPosition(ray, 0, 10, 0)

;Ray mesh
ray_m = xCreateCylinder ()
xPositionMesh ray_m,0,1,0
xScaleEntity ray_m,.1,5,.1


Repeat

If xKeyDown (205) x# = x+.1
If xKeyDown (203) x# = x-.1
If xKeyDown (200) z# = z+.1
If xKeyDown (208) z# = z-.1

xPositionEntity ray_m, x,0,z
pxRaySetPosition(ray, x, 10, z)

xPositionEntity sp,pxRayGetPickX(ray,0),pxRayGetPickY(ray,0),pxRayGetPickZ(ray,0)

;physic
pxRenderPhysic(30,0)

xUpdatePhysxPose cubic
pxDX9BodySetEntity(cubic,xcubic)

xUpdatePhysxPose cubic1
pxDX9BodySetEntity(cubic1,xcubic1)

xUpdatePhysxPose cubic2
pxDX9BodySetEntity(cubic2,xcubic2)


If xKeyDown (57)
	body  = pxRayGetBody(ray, 1)
	If body pxBodyAddForce(body, 0,20,0, 0)
EndIf

xUpdateWorld()
xRenderWorld()
xText 5,25, "Arrow - control ray  "
xText 5,45, "Space - Add Force  "
xFlip
Until xKeyHit(1) Or xWinMessage("WM_CLOSE")
End