Include "b3d_dx9.bb"
xGraphics3D 800,600,32,0,1
SeedRnd MilliSecs ()

PxCreateWorld(1, "key")
pxSetGravity(0, -10, 0)

camera=xCreateCamera() 
light=xCreateLight()
xPositionEntity camera,60,115,-150
xRotateEntity camera,30,30,0

plane=xCreateCube( )
xScaleEntity plane, 200,0.1,200
xEntityColor plane,0,100,200

Create_Px_Rope(Rand(-20,20),5,Rand(-20,20),  140)

While Not xKeyDown( 1 ) Or xWinMessage("WM_CLOSE")

If xKeyHit(57)
	Create_Px_Rope(Rand(-20,20),5,Rand(-20,20),  140)
EndIf  

time=MilliSecs ()
pxRenderPhysic(30,0)
Update_Px_Cube()
New_time=MilliSecs ()-time


xUpdateWorld ()
xRenderWorld
   frames=frames+1  
   If MilliSecs()-render_time=>1000  fps1=frames : frames=0 : render_time=MilliSecs()  
xText 10,10,"FPS: "+fps1+"  dll time: "+New_time
xText 10,30,"space - add rope"
xFlip 
Wend 
End


Type Px_Cube
	Field cube_body%
	Field cube_mesh%
End Type


 Function Create_Px_Cube(x#, y#, z#,   pos_x#, pos_y#, pos_z#,  mass#)
   ocu.Px_Cube = New Px_Cube
  ocu\cube_mesh=xCreateCube ()
  xScaleEntity ocu\cube_mesh, x, y, z
  ocu\cube_body=PxBodyCreateCube(x, y, z, mass)

   pxBodySetPosition(ocu\cube_body, pos_x, pos_y, pos_z)
   Return ocu\cube_body

 End Function

Function Update_Px_Cube()
	For ocu.Px_Cube = Each Px_Cube
		xUpdatePhysxPose ocu\cube_mesh
        pxDX9BodySetEntity(ocu\cube_mesh, ocu\cube_body)
	Next
End Function

Function Create_Px_Rope(pos_x, pos_y,pos_z, amount%)
	ocu.Px_Cube = New Px_Cube
 	ocu\cube_mesh = Mesh_Capsule(6, 2)
	xEntityColor ocu\cube_mesh,Rand(0,255),Rand(0,255),Rand(0,255) 
  	ocu\cube_body=pxBodyCreateCapsule(6,2, 10)
	pxBodySetPosition(ocu\cube_body, pos_x+0.1, pos_y,pos_z+0.1)

	For i=0 To amount%
	  	ocu.Px_Cube = New Px_Cube
 			ocu\cube_mesh = Mesh_Capsule(6, 2)
			xEntityColor ocu\cube_mesh,Rand(0,255),Rand(0,255),Rand(0,255) 
  		 	ocu\cube_body=pxBodyCreateCapsule(6,2, 10)
		 	pos_y = pos_y+10
  		 	pxBodySetPosition(ocu\cube_body, pos_x, pos_y,pos_z)
	
			t = ocu\cube_body
			ocu= Before ocu
			joint = pxJointCreateSpherical(ocu\cube_body, t, pos_x,pos_y-5,pos_z,  0,1,0)
			pxJointSphericalSetLimitTwist(joint, -15,15,  500,0.5,0)
			pxJointSphericalSetLimitAngle(joint, 20, 0, 0)
			pxJointSphericalSetLimitSpring(joint, 500, 0.5, 0)
	Next
End Function

Function Mesh_Capsule(height#, radius#)
 ;------------------------create Mesh-------------
capsule= xCreateCylinder()
xScaleMesh capsule, radius, height/2, radius
xPositionMesh capsule,0,0,0

Return capsule
;----------------------------------------------------------------
 End Function
