Include "b3d_dx9.bb"

xGraphics3D 800,600,32,0,1
SeedRnd MilliSecs ()
Global n#,k=0,w=1.1 ,free,in_mesh,enable=1

pxCreateWorld(1, "key")
pxSetGravity(0, -10, 0)


camera=xCreateCamera() 
light=xCreateLight()
xPositionEntity camera,20,35,-30
xRotateEntity camera,30,30,0

plane=xCreateCube( )
xScaleEntity plane, 100,0.1,100
xEntityColor plane,0,100,200

;--------------Create Trimesh----------------

free= xLoadMesh("..\PhysX media\spring.b3d")
xScaleMesh free,0.2,0.2,0.2
xPositionEntity free,0,5,0
VB = xGetMeshVB(free)
VB_size = xGetMeshVBSize(free)
IB = xGetMeshIB(free )
IB_size=xGetMeshIBSize(free)
   in_mesh=pxCreateTriMesh(VB, IB, VB_size, IB_size, 0)
   pxBodySetPosition(in_mesh,0,5,0)

Create_Px_Sphere()

While Not xKeyDown( 1 ) Or xWinMessage("WM_CLOSE")


If xKeyHit(57)
  Create_Px_Sphere()
   k =k+1
EndIf  



If xKeyHit( 17 )=True Then enable=1-enable 

; Enable/disable wireframe rendering 
xWireFrame enable
  
time=MilliSecs ()
pxRenderPhysic(30,0)
Update_Px_Cube()
New_time=MilliSecs ()-time



If xKeyDown (17) i=i+4

xUpdateWorld ()
xRenderWorld

 xText 10,10,"FPS: "+xGetFPS()+"  dll time: "+New_time
 xText 10,30,"w -   Enable/disable wireframe rendering   "
 xText 10,50,"space - add sphere  "

xFlip 
Wend 

End


Type Px_Cube
	Field cube_body%
	Field cube_mesh%
End Type



 Function Create_Px_Sphere()
   ocu.Px_Cube = New Px_Cube

  ocu\cube_mesh=xCreateSphere ()
  xScaleEntity ocu\cube_mesh,0.5,0.5,0.5 
  ocu\cube_body=PxBodyCreateSphere(0.5, 1)

   pxBodySetPosition(ocu\cube_body,3,30,0)

 End Function

Function Update_Px_Cube()
	For ocu.Px_Cube = Each Px_Cube
          pxDX9BodySetEntity(ocu\cube_mesh, ocu\cube_body)
	Next
End Function


Function BodyCreateMesh(mesh%)

	nsurf = CountSurfaces(mesh)
	nvert = 0
	nface=0
	For ns = 1 To nsurf
		Local surf = GetSurface(mesh,ns)
		nface = nface+CountTriangles(surf)
		nvert = nvert +CountVertices(surf)
	Next

	fbank = CreateBank(nface*4*3)
	nf = 0
	vbank = CreateBank(nvert*4*3)
	nv = 0
	For ns = 1 To nsurf
		surf = GetSurface(mesh,ns)
		nfv = CountTriangles(surf)
		For nfc = 0 To nfv -1
			PokeInt fbank,nf*12+0,TriangleVertex(surf,nfc,0)
			PokeInt fbank,nf*12+4,TriangleVertex(surf,nfc,1)
			PokeInt fbank,nf*12+8,TriangleVertex(surf,nfc,2)
			nf=nf+1
		Next

		nvv = CountVertices(surf)
		For nvc = 0 To nvv - 1
			PokeFloat vbank,nv*12+0,VertexX(surf,nvc)
			PokeFloat vbank,nv*12+4,VertexY(surf,nvc)
			PokeFloat vbank,nv*12+8,VertexZ(surf,nvc)
			nv = nv+1
		Next
	Next
	bbb%=pxCreateTriMesh(vbank, fbank, nvert, nface,0)
	FreeBank vbank
	FreeBank fbank
	Return bbb%
End Function


