Include "b3d_dx9.bb"

xGraphics3D 800,600,32,0,1
SeedRnd MilliSecs ()
Global n#,k=0,w=1.1 ,sp


pxCreateWorld(1,"key")
pxSetGravity(0, -10, 0)

sp = xLoadMesh ("../PhysX media/teapot.b3d")
xScaleMesh sp,.1,.1,.1

  	VB = xGetMeshVB(sp)
	VB_size = xGetMeshVBSize(sp)
    cube_body=pxBodyCreateHull(VB, VB_size, 10)
    pxBodySetPosition(cube_body,0,40,0)

camera=xCreateCamera() 
light=xCreateLight()
xPositionEntity camera,30,55,-60
xRotateEntity camera,30,30,0

plane=xCreateCube( )
XScaleEntity plane, 100,0.1,100
xEntityColor plane,0,100,200


While Not xKeyDown( 1 ) Or xWinMessage("WM_CLOSE")


If xKeyHit(57) 
  Create_Hull()
   k =k+1
EndIf  

xUpdatePhysxPose sp
pxDX9BodySetEntity(sp, cube_body)
  
time=MilliSecs ()
pxRenderPhysic(30,0)
Update_Hull()
New_time=MilliSecs ()-time


xUpdateWorld ()
xRenderWorld
   frames=frames+1  
   If MilliSecs()-render_time=>1000  fps1=frames : frames=0 : render_time=MilliSecs()  
 xText 10,10,"FPS: "+fps1+"  dll time: "+New_time
 xText 10,50,"Space - add Teapot "
xFlip 
Wend 

End

Type Px_Cube
	Field cube_body%
	Field cube_mesh%
End Type


Function Create_Hull()
   ocu.Px_Cube = New Px_Cube

   ocu\cube_mesh=xLoadMesh ("../PhysX media/teapot.b3d")
   xScaleMesh  ocu\cube_mesh,.1,.1,.1

  	VB = xGetMeshVB(ocu\cube_mesh)
	VB_size = xGetMeshVBSize(ocu\cube_mesh)
   ocu\cube_body=pxBodyCreateHull(VB, VB_size, 10)
   
   pxBodySetPosition(ocu\cube_body,Rand(-10,20),Rand(35,50),Rand(-10,20))
   pxBodySetRotation(ocu\cube_body,Rand(-50,50),Rand(50,50),Rand(-50,50))
   xScaleEntity ocu\cube_mesh,1,1,1
 End Function

Function Update_Hull()
	For ocu.Px_Cube = Each Px_Cube
		xUpdatePhysxPose ocu\cube_mesh
        pxDX9BodySetEntity(ocu\cube_mesh, ocu\cube_body)
	Next
End Function

