Include "b3d_dx9.bb"

xGraphics3D 800, 600,32,0,1
SeedRnd MilliSecs ()
Global k=0,kil


PxCreateWorld(1,"key")
pxSetGravity(0, -10, 0)


camera=xCreateCamera() 
light=xCreateLight()
xPositionEntity camera,30,65,-80
xRotateEntity camera,30,30,0

plane=xCreateCube( )
XScaleEntity plane, 100,0.1,100
xEntityColor plane,0,100,200
 
   Create_Px_Stack(30)


While Not xKeyDown( 1 ) Or xWinMessage("WM_CLOSE")

If xKeyHit(57)
   Create_Px_Cube()
   k =k+1
EndIf  
  
time=MilliSecs ()
pxRenderPhysic(60,0)
Update_Px_Cube()
New_time=MilliSecs ()-time

xUpdateWorld ()
xRenderWorld

 xText 10,10,"FPS: "+xGetFPS()+"  dll time: "+New_time
 xText 10,30,"space - add cube"

xFlip
Wend 
pxDestroyWorld()
End


Type Px_Cube
	Field cube_body%
	Field cube_mesh%
End Type

Function Create_Px_Cube()
   ocu.Px_Cube = New Px_Cube
		ocu\cube_body=pxBodyCreateSphere(2, 10)
 		ocu\cube_mesh=xCreateSphere()
		xScaleEntity ocu\cube_mesh,2,2,2
		xEntityColor ocu\cube_mesh,Rand(0,255),Rand(0,255),Rand(0,255) 
		pxBodySetPosition(ocu\cube_body,Rand(-20,20),Rand(5,40),-50)
		pxBodySetRotation(ocu\cube_body,Rand(-90,90),Rand(-90,90),Rand(-90,90))
		
	  pxBodyAddForce(ocu\cube_body, 0, 0, 300, 2)
 End Function

Function Update_Px_Cube()
	For ocu.Px_Cube = Each Px_Cube
		pxBodySetSleepWakeUp(ocu\cube_body, 1)
		xUpdatePhysxPose(ocu\cube_mesh)
        pxDX9BodySetEntity(ocu\cube_mesh, ocu\cube_body)
	Next
End Function

Function Create_Px_Stack(size%)
	CubeSize = 1.0
	Spacing = 0.01
	pos_y = CubeSize
	Offset = -size * (CubeSize * 2.0 + Spacing) * 0.5
	While size
			For  i=0 To size-1
			mas=mas+1
					ocu.Px_Cube = New Px_Cube
					Pos_x = Offset + i * (CubeSize * 2.0 + Spacing)
					ocu\cube_body=PxBodyCreateCube(CubeSize ,CubeSize ,CubeSize , 0.1)

   					ocu\cube_mesh=xCreateCube()
					xScaleEntity ocu\cube_mesh, CubeSize ,CubeSize ,CubeSize 
					xEntityColor ocu\cube_mesh,Rand(0,255),Rand(0,255),Rand(0,255)
   					pxBodySetPosition(ocu\cube_body, pos_x,pos_y,0)
					pxBodySetRotation (ocu\cube_body, rot_x, rot_y, rot_z)
					kil=kil+1
					k=k+1
			Next
		Offset = Offset +CubeSize;
		pos_y =  pos_y +(CubeSize * 2.0 + Spacing)
		size=size-1
	Wend 
End Function
