Include "b3d_dx9.bb"
xGraphics3D 800, 600,32,0,1

SeedRnd MilliSecs ()

PxCreateWorld(1, "key")
pxSetGravity(0, -10, 0)

body=PxBodyCreateCube(12,1,28, 0)
cu= xCreateCube ()
xScaleEntity cu,12,1,28
pxBodySetPosition(body, 0,20,0)
pxBodySetRotation(body, 0, 0, 30)


;=============Create cube0=========
body0=PxBodyCreateCube(1,1,1, 20)
cu0= xCreateCube ()
pxBodySetPosition(body0,8,35,16)
xEntityColor cu0, 255,50,50
pxBodySetRotation(body0, 0,0,30)

mat0=pxCreateMaterial()
pxMaterialSetToBody(body0, mat0)
pxMaterialSetRestitution(mat0,2.0)

;=============Create cube1=========
body1=PxBodyCreateCube(1,1,1, 20)
cu1= xCreateCube ()
pxBodySetPosition(body1,8,35,8)
xEntityColor cu1, 50,250,50
pxBodySetRotation(body1, 0,0,30)

;=============Create cube2=========
body2=PxBodyCreateCube(1,1,1, 20)
cu2= xCreateCube ()
pxBodySetPosition(body2,8,35,0)
xEntityColor cu2, 50,50,250
pxBodySetRotation(body2, 0,0,30)

mat2=pxCreateMaterial()
pxMaterialSetFrictionCombineMode(mat2, 2)
pxMaterialSetToBody(body2, mat2)
pxMaterialSetStFriction(mat2, 0)
pxMaterialSetDyFriction(mat2, 0)


camera=xCreateCamera() 
light=xCreateLight()
xPositionEntity camera,-10,55,-80
xRotateEntity camera,30,0,0

plane=xCreateCube( )
XScaleEntity plane, 100,0.1,100
xEntityColor plane,0,100,200


While Not xKeyDown( 1 ) Or xWinMessage("WM_CLOSE")
  
time=MilliSecs ()
pxRenderPhysic(30,0)
New_time=MilliSecs ()-time

xUpdatePhysxPose(cu)
pxDX9BodySetEntity(cu, body)

xUpdatePhysxPose(cu0)
pxDX9BodySetEntity(cu0, body0)

xUpdatePhysxPose(cu1)
pxDX9BodySetEntity(cu1, body1)

xUpdatePhysxPose(cu2)
pxDX9BodySetEntity(cu2, body2)


xUpdateWorld ()
xRenderWorld

 xText 10,10,"FPS: "+xGetFPS()+"  dll time: "+New_time

xFlip 
Wend 

End



